/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.commons.VoipAntiSpamListNumbersStatus;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.VoipAntiSpamListNumbersStatusConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.VoipAntiSpamGrayListNumbersRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VoipAntiSpamGrayListNumbers extends TableImpl<VoipAntiSpamGrayListNumbersRecord> {

	private static final long serialVersionUID = -810095741;

	/**
	 * The reference instance of <code>public.voip_anti_spam_gray_list_numbers</code>
	 */
	public static final VoipAntiSpamGrayListNumbers VOIP_ANTI_SPAM_GRAY_LIST_NUMBERS = new VoipAntiSpamGrayListNumbers();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<VoipAntiSpamGrayListNumbersRecord> getRecordType() {
		return VoipAntiSpamGrayListNumbersRecord.class;
	}

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.number</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, String> NUMBER = createField("number", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.block_time</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, Date> BLOCK_TIME = createField("block_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.block_count</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, Integer> BLOCK_COUNT = createField("block_count", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.block_time_left</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, Date> BLOCK_TIME_LEFT = createField("block_time_left", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.routing_request_count</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, Integer> ROUTING_REQUEST_COUNT = createField("routing_request_count", org.jooq.impl.SQLDataType.INTEGER.defaulted(true), this, "");

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.status</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, VoipAntiSpamListNumbersStatus> STATUS = createField("status", org.jooq.impl.SQLDataType.CLOB.nullable(false).defaulted(true), this, "", new VoipAntiSpamListNumbersStatusConverter());

	/**
	 * The column <code>public.voip_anti_spam_gray_list_numbers.status_description</code>.
	 */
	public final TableField<VoipAntiSpamGrayListNumbersRecord, String> STATUS_DESCRIPTION = createField("status_description", org.jooq.impl.SQLDataType.CLOB.nullable(false).defaulted(true), this, "");

	/**
	 * Create a <code>public.voip_anti_spam_gray_list_numbers</code> table reference
	 */
	public VoipAntiSpamGrayListNumbers() {
		this("voip_anti_spam_gray_list_numbers", null);
	}

	/**
	 * Create an aliased <code>public.voip_anti_spam_gray_list_numbers</code> table reference
	 */
	public VoipAntiSpamGrayListNumbers(String alias) {
		this(alias, VOIP_ANTI_SPAM_GRAY_LIST_NUMBERS);
	}

	private VoipAntiSpamGrayListNumbers(String alias, Table<VoipAntiSpamGrayListNumbersRecord> aliased) {
		this(alias, aliased, null);
	}

	private VoipAntiSpamGrayListNumbers(String alias, Table<VoipAntiSpamGrayListNumbersRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<VoipAntiSpamGrayListNumbersRecord> getPrimaryKey() {
		return Keys.VOIP_ANTI_SPAM_GRAY_LIST_NUMBERS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<VoipAntiSpamGrayListNumbersRecord>> getKeys() {
		return Arrays.<UniqueKey<VoipAntiSpamGrayListNumbersRecord>>asList(Keys.VOIP_ANTI_SPAM_GRAY_LIST_NUMBERS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public VoipAntiSpamGrayListNumbers as(String alias) {
		return new VoipAntiSpamGrayListNumbers(alias, this);
	}

	/**
	 * Rename this table
	 */
	public VoipAntiSpamGrayListNumbers rename(String name) {
		return new VoipAntiSpamGrayListNumbers(name, null);
	}
}
